Subject: Re: [PATCH] t9604: Fix test for musl libc and new Debian

From: Đoàn Trần Công Danh <[email-masked]>
Date: Sun, 7 Apr 2024 08:50:06 +0700

On 2024-04-07 08:45:38+0700, Đoàn Trần Công Danh <[email-masked]> wrote:
> On 2024-04-06 21:33:12-0400, Jeff King <[email-masked]> wrote:
> > On Sat, Apr 06, 2024 at 10:29:10AM +0700, Đoàn Trần Công Danh wrote:
> > 
> > > CST6CDT and the like are POSIX timezone, with no rule for transition.
> > > And POSIX doesn't enforce how to interpret the rule if it's omited.
> > > Some libc resorted back to IANA (formerly Olson) db rules for those
> > > timezones.  Other libc (e.g. musl) interpret that as no transition at
> > > all [1].
> > > 
> > > In addition, distributions (notoriously Debian-derived, which uses IANA
> > > db for CST6CDT and the like) started to split "legacy" timezones
> > > like CST6CDT, EST5EDT into `tzdata-legacy', which will not be installed
> > > by default [2].
> > > 
> > > In those cases, t9604 will run into failure.
> > > 
> > > Let's switch to POSIX timezone with rules to change timezone.
> > 
> > This made me wonder if we are losing EST5, etc. We use that in t0006,
> > for example. But I guess not, since I do not have tzdata-legacy
> > installed (I am on Debian unstable) and haven't run into issues (I
> > didn't notice the cvsimport one because I lack other prereqs to run
> > those tests).
> 
> Nah, EST5 is a conformance POSIX timezone.  It read:
> 
>     The timezone name is EST, offset is 5hours behinds Universal timezone.

Correction: it reads
      The timezone name is EST, offset is 5hours behinds Universal timezone,
      all year round.

Since POSIX says that:

	if dst is missing, then the alternative time does not apply in
	this locale.

> 
> You can check by trying today (or on anyday with DST on):
> 
> 	TZ=EST5 date
> 	TZ=EST5EDT date
> 	TZ=America/New_York date
> 
> - The first one will always interpret 5 hours behinds UTC.
> - The second one is implementation defined behavior, on glibc system,
>   it will depends on the existence of /usr/share/zoneinfo/EST5EDT
> - The third one will interpret today time as 4 hours behinds UTC.
> 
> glibc normally check if a timezone exist in /usr/share/zoneinfo first,
> if not, it will interpret by POSIX rule.
> 
> -- 
> Danh

-- 
Danh